import { IQueryHandler, QueryHandler } from '@nestjs/cqrs';
import { Inject } from '@nestjs/common';
import { DecisionQuery } from './decision.query';
import { DECISION_MAKER } from '@modules/authorization/authorization.di-tokens';
import { DecisionMakerPort } from '../../ports/decision-maker.port';

@QueryHandler(DecisionQuery)
export class DecisionQueryHandler implements IQueryHandler {
  constructor(
    @Inject(DECISION_MAKER)
    private readonly decisionMaker: DecisionMakerPort,
  ) {}

  execute = async (decisionQuery: DecisionQuery): Promise<boolean> =>
    this.decisionMaker.decide(
      decisionQuery.domain,
      decisionQuery.action,
      decisionQuery.context,
    );
}
